(function (window) {
  console.log('HZRECORDER is initing!!!!!!!!');

  //兼容
  window.URL = window.URL || window.webkitURL;
  navigator.getUserMedia = navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia || navigator.msGetUserMedia;

  var userAgent = navigator.userAgent;
  var isSafari = userAgent.indexOf('Safari') > -1 && userAgent.indexOf('Chrome') < 1;
  var isIE = userAgent.indexOf('Safari') == -1 && userAgent.indexOf('Chrome') == -1 && userAgent.indexOf('Firefox') == -1;
  var isMac = navigator.appVersion.indexOf('Mac') > -1;

  var HZRecorder = function (stream, config) {
    console.log('Here is the stream', stream);
    config = config || {};
    config.sampleBits = config.sampleBits || 16; //采样数位 8, 16
    config.sampleRate = config.sampleRate || 16000; //采样率(1/6 44100)

    var context = new (window.webkitAudioContext || window.AudioContext)();
    var audioInput = context.createMediaStreamSource(stream);
    var createScript = context.createScriptProcessor || context.createJavaScriptNode;
    var recorder = createScript.apply(context, [4096, 1, 1]);
    console.log('Here is config', config);
    console.log('Here is the context', context);

    var audioData = {
      size: 0, //录音文件长度
      sizeForPlay: 0, //录音文件长度
      inputData: [],
      buffer: [], //录音缓存
      bufferForPlay: [], //录音缓存
      inputSampleRate: context.sampleRate, //输入采样率
      inputSampleBits: 16, //输入采样数位 8, 16
      outputSampleRate: config.sampleRate, //输出采样率 16000 只有这个采样率算法能够识别
      oututSampleBits: config.sampleBits, //输出采样数位 8, 16
      outputSampleRateForPlay: 44100, //输出采样率
      oututSampleBitsForPlay: 16, //输出采样数位 8, 16

      input: function (data) {
        this.inputData = data;
        this.buffer.push(new Float32Array(data));
        this.size += data.length;
      },

      compress: function () {
        //合并压缩
        //合并
        var data = new Float32Array(this.size);
        var offset = 0;
        for (var i = 0; i < this.buffer.length; i++) {
          data.set(this.buffer[i], offset);
          offset += this.buffer[i].length;
        }
        //压缩
        var compression = parseInt(this.inputSampleRate / this.outputSampleRate);
        var length = data.length / compression;
        var result = new Float32Array(length);
        var index = 0,
          j = 0;
        while (index < length) {
          result[index] = data[j];
          j += compression;
          index++;
        }
        return result;
      },

      compressForPlay: function () {
        //合并压缩
        //合并
        var data = new Float32Array(this.size);
        var offset = 0;
        for (var i = 0; i < this.buffer.length; i++) {
          data.set(this.buffer[i], offset);
          offset += this.buffer[i].length;
        }
        //压缩
        var compression = parseInt(this.inputSampleRate / this.outputSampleRateForPlay); // 不压缩
        var length = data.length / compression;
        var result = new Float32Array(length);
        var index = 0,
          j = 0;
        while (index < length) {
          result[index] = data[j];
          j += compression;
          index++;
        }
        return result;
      },

      encodeWAV: function () {
        var sampleRate = Math.min(this.inputSampleRate, this.outputSampleRate);
        var sampleBits = Math.min(this.inputSampleBits, this.oututSampleBits);
        var bytes = this.compress();
        var dataLength = bytes.length * (sampleBits / 8);
        var buffer = new ArrayBuffer(44 + dataLength);
        var data = new DataView(buffer);
        var channelCount = 1; //单声道
        var offset = 0;

        var writeString = function (str) {
          for (var i = 0; i < str.length; i++) {
            data.setUint8(offset + i, str.charCodeAt(i));
          }
        };

        // 资源交换文件标识符
        writeString('RIFF');
        offset += 4;
        // 下个地址开始到文件尾总字节数,即文件大小-8
        data.setUint32(offset, 36 + dataLength, true);
        offset += 4;
        // WAV文件标志
        writeString('WAVE');
        offset += 4;
        // 波形格式标志
        writeString('fmt ');
        offset += 4;
        // 过滤字节,一般为 0x10 = 16
        data.setUint32(offset, 16, true);
        offset += 4;
        // 格式类别 (PCM形式采样数据)
        data.setUint16(offset, 1, true);
        offset += 2;
        // 通道数
        data.setUint16(offset, channelCount, true);
        offset += 2;
        // 采样率,每秒样本数,表示每个通道的播放速度
        data.setUint32(offset, sampleRate, true);
        offset += 4;
        // 波形数据传输率 (每秒平均字节数) 单声道×每秒数据位数×每样本数据位/8
        data.setUint32(offset, channelCount * sampleRate * (sampleBits / 8), true);
        offset += 4;
        // 快数据调整数 采样一次占用字节数 单声道×每样本的数据位数/8
        data.setUint16(offset, channelCount * (sampleBits / 8), true);
        offset += 2;
        // 每样本数据位数
        data.setUint16(offset, sampleBits, true);
        offset += 2;
        // 数据标识符
        writeString('data');
        offset += 4;
        // 采样数据总数,即数据总大小-44
        data.setUint32(offset, dataLength, true);
        offset += 4;
        // 写入采样数据
        if (sampleBits === 8) {
          for (var i = 0; i < bytes.length; i++, offset++) {
            var s = Math.max(-1, Math.min(1, bytes[i]));
            var val = s < 0 ? s * 0x8000 : s * 0x7fff;
            val = parseInt(255 / (65535 / (val + 32768)));
            data.setInt8(offset, val, true);
          }
        } else {
          for (var i = 0; i < bytes.length; i++, offset += 2) {
            var s = Math.max(-1, Math.min(1, bytes[i]));
            data.setInt16(offset, s < 0 ? s * 0x8000 : s * 0x7fff, true);
          }
        }
        return new Blob([data], { type: 'audio/wav' });
      },

      encodeWAVNext: function () {
        // var sampleRate = Math.min(this.inputSampleRate, this.outputSampleRate);
        var sampleBits = Math.min(this.inputSampleBits, this.oututSampleBits);
        var bytes = this.compress();
        var dataLength = bytes.length * (sampleBits / 8);
        var buffer = new ArrayBuffer(44 + dataLength);
        var data = new DataView(buffer);
        // var channelCount = 1;//单声道
        var offset = 0;

        // 写入采样数据
        if (sampleBits === 8) {
          for (var i = 0; i < bytes.length; i++, offset++) {
            var s = Math.max(-1, Math.min(1, bytes[i]));
            var val = s < 0 ? s * 0x8000 : s * 0x7fff;
            val = parseInt(255 / (65535 / (val + 32768)));
            data.setInt8(offset, val, true);
          }
        } else {
          for (var i = 0; i < bytes.length; i++, offset += 2) {
            var s = Math.max(-1, Math.min(1, bytes[i]));
            data.setInt16(offset, s < 0 ? s * 0x8000 : s * 0x7fff, true);
          }
        }
        return new Blob([data], { type: 'audio/wav' });
      },

      encodeWAVForPlay: function () {
        var sampleRate = Math.min(this.inputSampleRate, this.outputSampleRateForPlay);
        var sampleBits = Math.min(this.inputSampleBits, this.oututSampleBitsForPlay);
        var bytes = this.compressForPlay();
        var dataLength = bytes.length * (sampleBits / 8);
        var buffer = new ArrayBuffer(44 + dataLength);
        var data = new DataView(buffer);

        var channelCount = 1; //单声道
        var offset = 0;

        var writeString = function (str) {
          for (var i = 0; i < str.length; i++) {
            data.setUint8(offset + i, str.charCodeAt(i));
          }
        };

        // 资源交换文件标识符
        writeString('RIFF');
        offset += 4;
        // 下个地址开始到文件尾总字节数,即文件大小-8
        data.setUint32(offset, 36 + dataLength, true);
        offset += 4;
        // WAV文件标志
        writeString('WAVE');
        offset += 4;
        // 波形格式标志
        writeString('fmt ');
        offset += 4;
        // 过滤字节,一般为 0x10 = 16
        data.setUint32(offset, 16, true);
        offset += 4;
        // 格式类别 (PCM形式采样数据)
        data.setUint16(offset, 1, true);
        offset += 2;
        // 通道数
        data.setUint16(offset, channelCount, true);
        offset += 2;
        // 采样率,每秒样本数,表示每个通道的播放速度
        data.setUint32(offset, sampleRate, true);
        offset += 4;
        // 波形数据传输率 (每秒平均字节数) 单声道×每秒数据位数×每样本数据位/8
        data.setUint32(offset, channelCount * sampleRate * (sampleBits / 8), true);
        offset += 4;
        // 快数据调整数 采样一次占用字节数 单声道×每样本的数据位数/8
        data.setUint16(offset, channelCount * (sampleBits / 8), true);
        offset += 2;
        // 每样本数据位数
        data.setUint16(offset, sampleBits, true);
        offset += 2;
        // 数据标识符
        writeString('data');
        offset += 4;
        // 采样数据总数,即数据总大小-44
        data.setUint32(offset, dataLength, true);
        offset += 4;
        // 写入采样数据
        if (sampleBits === 8) {
          for (var i = 0; i < bytes.length; i++, offset++) {
            var s = Math.max(-1, Math.min(1, bytes[i]));
            var val = s < 0 ? s * 0x8000 : s * 0x7fff;
            val = parseInt(255 / (65535 / (val + 32768)));
            data.setInt8(offset, val, true);
          }
        } else {
          for (var i = 0; i < bytes.length; i++, offset += 2) {
            var s = Math.max(-1, Math.min(1, bytes[i]));
            data.setInt16(offset, s < 0 ? s * 0x8000 : s * 0x7fff, true);
          }
        }

        return new Blob([data], { type: 'audio/wav' });
      }
    };

    //开始录音
    this.start = function () {
      audioInput.connect(recorder);
      recorder.connect(context.destination);
    };

    //停止
    this.stop = function () {
      recorder.disconnect();
    };

    this.destroy = function () {
      recorder.disconnect();
      var tracks = (stream.getTracks && stream.getTracks()) || stream.audioTracks || [];
      for (var i = 0; i < tracks.length; i++) {
        var track = tracks[i];
        track.stop && track.stop();
      }
      stream.stop && stream.stop();
    };

    //获取音频文件 给算法的
    this.getBlob = function () {
      this.stop();
      return audioData.encodeWAV();
    };

    this.getWav = function () {
      return audioData.encodeWAV();
    };

    this.getWavNext = function () {
      return audioData.encodeWAVNext();
    };

    this.getInputData = function () {
      return audioData.inputData;
    };

    //获取音频文件 给网页播放器的
    this.getBlobForPlay = function () {
      this.stop();
      return audioData.encodeWAVForPlay();
    };

    this.clear = function () {
      audioData.size = 0;
      audioData.buffer = [];
      audioData.sizeForPlay = 0;
      audioData.bufferForPlay = [];
    };

    //回放
    this.play = function (audio) {
      if (isMac) {
        audio.src = window.URL.createObjectURL(this.getBlobForPlay());
      } else {
        audio.src = window.URL.createObjectURL(this.getBlob());
      }
    };

    //停止播放
    this.stopPlay = function (audio) {
      audio.src = '';
    };

    //上传
    this.upload = function (callback) {
      callback(this.getBlob());
    };

    //音频采集
    recorder.onaudioprocess = function (e) {
      audioData.input(e.inputBuffer.getChannelData(0));
      // audioData.inputForPlay(e.inputBuffer.getChannelData(0));
      //record(e.inputBuffer.getChannelData(0));
    };
  };

  //抛出异常
  HZRecorder.throwError = function (message) {
    console.log(message);
    // throw new function () { this.toString = function () { return message; } }
  };

  //是否支持录音
  HZRecorder.canRecording = navigator.getUserMedia != null;

  //获取录音机
  HZRecorder.get = function (callback, config) {
    if (!callback) {
      return;
    }

    if (!navigator.mediaDevices || !navigator.mediaDevices.getUserMedia) {
      callback(null, 'Other');
      HZRecorder.throwError('当前浏览器不支持录音功能。若要通过麦克风使用自己的声音尝试演示，请改用支持 WebRTC 的其他浏览器，例如，最新版本的 Microsoft Edge、Firefox 或 Chrome。');
      return;
    }

    navigator.mediaDevices.getUserMedia({ audio: true }).then(
      stream => {
        var rec = new HZRecorder(stream, config);
        callback(rec, null);
      },
      error => {
        switch (error.code || error.name) {
          case 'PERMISSION_DENIED':
          case 'PermissionDeniedError':
            callback(null, 'PermissionDeniedError');
            HZRecorder.throwError('用户拒绝提供信息。');
            break;
          case 'NOT_SUPPORTED_ERROR':
          case 'NotSupportedError':
            callback(null, 'NotSupportedError');
            HZRecorder.throwError('浏览器不支持硬件设备。');
            break;
          case 'MANDATORY_UNSATISFIED_ERROR':
          case 'MandatoryUnsatisfiedError':
            callback(null, 'MandatoryUnsatisfiedError');
            HZRecorder.throwError('无法发现指定的硬件设备。');
            break;
          default:
            callback(null, 'NotOpenMike');
            HZRecorder.throwError('无法打开麦克风。异常信息:' + (error.code || error.name));
            break;
        }
      }
    );
  };

  window.HZRecorder = HZRecorder;
})(window);
